#include "Jester.h"
#include "Global.h"

void GameMain()
{
	GetInput();
	GameLogic();
	Collision();
	Render();
}

void GameLogic()
{
	Player.y1 = 600-(Game.MousePos.y+20);
	Player.y2 = 600-(Game.MousePos.y-20);
	
	if(Enemy.Health <= 0)
	{
		int h = 0;
		Game.Enemy++;
		Enemy.Health = 100;
		switch(Game.Enemy)
		{
		case 2:
			Game.Difficulty = 250;
			for(h = 0; h < 100; h++) EWeap[h].vy = 110;
			break;

		case 3:
			Game.Difficulty = 200;
			for(h = 0; h < 100; h++) EWeap[h].vy = 160;
			break;

		case 4:
			Game.Difficulty = 150;
			for(h = 0; h < 100; h++) EWeap[h].vy = 200;
			break;

		case 5:
			Game.Win = true;
			PostQuitMessage(0);
			return;
		}
	}

	if(Player.Health <= 0)
	{
		Game.Lose = true;
		PostQuitMessage(0);
		return;
	}
	
	static DWORD oldtime = 0;
	if(Player.Shooting)
	{
		if(timeGetTime() > oldtime)
		{
			for(int i = 0; i < 200; i++)
			{
				if(!PWeap[i].Active)
				{
					PWeap[i].Active = true;
					PWeap[i].x1 = Player.x1;
					PWeap[i].y1 = Player.y1-20+(rand()%40);
					PWeap[i].x2 = PWeap[i].x1+20;
					PWeap[i].y2 = PWeap[i].y1+20;
					PWeap[i].type = (rand()%7);	
					break;
				}
			}
			oldtime = timeGetTime()+100;
		}
	}

	for(int g = 0; g < 200; g++)
	{
		if(PWeap[g].Active)
		{
			PWeap[g].x1 += PWeap[g].vx*(1.0f/75);
			PWeap[g].x2 += PWeap[g].vx*(1.0f/75);

			if(PWeap[g].x2 < 0) PWeap[g].Active = false;
		}
	}

	static DWORD lastEshoot = 0;
	if(timeGetTime() > lastEshoot)
	{
		Enemy.Shooting = true;
		lastEshoot = timeGetTime()+100+(rand()%Game.Difficulty);
	}
	else Enemy.Shooting = false;

	if(Enemy.y1 > Player.y2)
	{
		Enemy.vy = -150;
	}
	else if(Enemy.y2 < Player.y1)
	{
		Enemy.vy = 150;
	}

	Enemy.y1 += Enemy.vy*(1.0f/75);
	Enemy.y2 += Enemy.vy*(1.0f/75);

	static DWORD oldtime2 = 0;
	if(Enemy.Shooting)
	{
		if(timeGetTime() > oldtime2)
		{
			for(int h = 0; h < 100; h++)
			{
				if(!EWeap[h].Active)
				{
					EWeap[h].Active = true;
					EWeap[h].x1 = Enemy.x1;
					EWeap[h].y1 = Enemy.y1+10;
					EWeap[h].x2 = EWeap[h].x1+20;
					EWeap[h].y2 = EWeap[h].y1+20;
					break;
				}
			}
			oldtime2 = timeGetTime()+150;
		}
	}

	for(int u = 0; u < 100; u++)
	{
		if(EWeap[u].Active)
		{
			EWeap[u].x1 += EWeap[u].vx*(1.0f/75);
			EWeap[u].x2 += EWeap[u].vx*(1.0f/75);

			if(EWeap[u].y1+10 > Player.y2)
			{
				EWeap[u].y1 -= EWeap[u].vy*(1.0f/75);
				EWeap[u].y2 -= EWeap[u].vy*(1.0f/75);
			}
			else if(EWeap[u].y1+10 < Player.y1)
			{
				EWeap[u].y1 += EWeap[u].vy*(1.0f/75);
				EWeap[u].y2 += EWeap[u].vy*(1.0f/75);
			}

			if(EWeap[u].x2 > 800) EWeap[u].Active = false;
		}
	}
}

void Collision()
{
	for(int i = 0; i < 100; i++)
	{
		if(EWeap[i].Active && (EWeap[i].x2 > Player.x1)&&(EWeap[i].x1 < Player.x2)&&
		   (EWeap[i].y1 < Player.y2) && (EWeap[i].y2 > Player.y1))
		{
			EWeap[i].Active = false;
			Player.Health -=1;
		}
	}

	for(int k = 0; k < 200; k++)
	{
		if(PWeap[k].Active && (PWeap[k].x1 < Enemy.x2)&&(PWeap[k].x2 < Enemy.x1)&&
		   (PWeap[k].y1 < Enemy.y2) && (PWeap[k].y2 > Enemy.y1))
		{
			PWeap[k].Active = false;
			Enemy.Health -=2;
		}
	}
}

void Render()
{
	Jester->BeginFrame();
	Jester->DrawSprite(g_YoMama, Player.x1, Player.y1);

	for(int g = 0; g < 200; g++)
	{
		if(PWeap[g].Active)
		{
			Jester->DrawSprite(g_PlayerFood[PWeap[g].type], PWeap[g].x1, PWeap[g].y1);
		}
	}

	int f = 0;
	switch(Game.Enemy)
	{
	case 1:
		Jester->DrawSprite(g_Fire, Enemy.x1, Enemy.y1);
		for(f = 0; f < 100; f++)
		{
			if(EWeap[f].Active)
			{
				Jester->DrawSprite(g_FireWeapon, EWeap[f].x1, EWeap[f].y1);
			}
		}
		break;

	case 2:
		Jester->DrawSprite(g_Wind, Enemy.x1, Enemy.y1);
		for(f = 0; f < 100; f++)
		{
			if(EWeap[f].Active)
			{
				Jester->DrawSprite(g_WindWeapon, EWeap[f].x1, EWeap[f].y1);
			}
		}
		break;

	case 3:
		Jester->DrawSprite(g_Earth, Enemy.x1, Enemy.y1);
		for(f = 0; f < 100; f++)
		{
			if(EWeap[f].Active)
			{
				Jester->DrawSprite(g_EarthWeapon, EWeap[f].x1, EWeap[f].y1);
			}
		}
		break;

	case 4:
		Jester->DrawSprite(g_Water, Enemy.x1, Enemy.y1);
		for(f = 0; f < 100; f++)
		{
			if(EWeap[f].Active)
			{
				Jester->DrawSprite(g_WaterWeapon, EWeap[f].x1, EWeap[f].y1);
			}
		}
		break;
	default: return;
	}
	
	char buff[30];
	sprintf(buff, "YoMama's Health: %d", Player.Health);
	Jester->TextOutWhite(5, 585, buff);

	sprintf(buff, "Enemy's Health: %d", Enemy.Health);
	Jester->TextOutWhite(5, 5, buff);
	Jester->EndFrame();
}



