#include "Jester.h"

int CJester::CreateSprite(char* Filename, int x1, int y1, int x2, int y2)
{
	if(!CheckExists(Filename))
	{
		JesterOptions.Failed = 1;
		return 0;
	}
	static int SpriteID = 0;
	SpriteID++;
	if(!(TextureList->TextureLoaded(Filename))) TextureList->Insert(Filename);
	
	SpriteList->Insert(Filename, SpriteID, x1, y1, x2, y2);
	return SpriteID;
}

void CJester::DrawSprite(int ID, int x, int y)
{
	y -= 300;
	x -= 400;

	D3DXMATRIX Position;
	D3DXMatrixTranslation(&Position, (float)x, (float)y, 0.0f);
	pd3dDevice->SetTransform(D3DTS_WORLD, &Position);

	pd3dDevice->SetTexture(0, TextureList->GetTexture(SpriteList->GetTextureString(ID)));
	pd3dDevice->SetVertexShader(D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1);

	pd3dDevice->SetStreamSource(0, SpriteList->GetVertBuff(ID), sizeof(CFVFVertex));
	pd3dDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
}

void CJester::DrawScaledSprite(int ID, int x, int y, int scaledPercent)
{
	
}

void CJester::DrawRotatedSprite(int ID, int x, int y, float _angle, char dimension)
{
	float angle = _angle*3.141592654f/180.0f;
	D3DXMATRIX Rotation;
	switch(dimension)
	{
	case 'x':
	case 'X':
		D3DXMatrixRotationX(&Rotation, angle);
		break;

	case 'y':
	case 'Y':
		D3DXMatrixRotationY(&Rotation, angle);
		break;

	case 'z':
	case 'Z':
	default:
		D3DXMatrixRotationZ(&Rotation, angle);
		break;
	}

	D3DXMATRIX Position;
	D3DXMatrixTranslation(&Position, (float)x, (float)y, 0.0f);

	D3DXMATRIX mat;
	mat = Rotation*Position;

	pd3dDevice->SetTransform(D3DTS_WORLD, &mat);

	pd3dDevice->SetTexture(0, TextureList->GetTexture(SpriteList->GetTextureString(ID)));
	pd3dDevice->SetVertexShader(D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1);
	pd3dDevice->SetStreamSource(0, SpriteList->GetVertBuff(ID), sizeof(CFVFVertex));

	pd3dDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
}