#include "Jester.h"
#include <fstream>
using namespace std;

// CSpriteList implimentation
CSpriteList::CSpriteList()
{
	myHead = new CSpriteHead;
}

CSpriteList::~CSpriteList()
{
	delete myHead;
}

void CSpriteList::Insert(char *Texture, int SpriteID, int x1, int y1, int x2, int y2)
{
	myHead->Insert(Texture, SpriteID, x1, y1, x2, y2);
}

IDirect3DVertexBuffer8* CSpriteList::GetVertBuff(int ID)
{
	return myHead->GetVertBuff(ID);
}

char* CSpriteList::GetTextureString(int ID)
{
	return myHead->GetTextureString(ID);
}

// CSpriteHead implimentation
CSpriteHead::CSpriteHead()
{
	myNext = new CSpriteTail;
}

CSpriteHead::~CSpriteHead()
{
	delete myNext;
}

IDirect3DVertexBuffer8* CSpriteHead::GetVertBuff(int ID)
{
	return myNext->GetVertBuff(ID);
}

char* CSpriteHead::GetTextureString(int ID)
{
	return myNext->GetTextureString(ID);
}

void CSpriteHead::Insert(char *Texture, int SpriteID, int x1, int y1, int x2, int y2)
{
	myNext = new CSpriteNode(Texture, SpriteID, x1, y1, x2, y2, myNext);
}

// CSpriteNode implimentation
CSpriteNode::CSpriteNode(){}

CSpriteNode::~CSpriteNode()
{
	delete myNext;
	delete[] myTextureName;
	delete[] myVertices;
	delete myNext;
	delete myVB;
}

CSpriteNode::CSpriteNode(char *Texture, int SpriteID, int x1, int y1, int x2, int y2, CSpriteNode* myNewNext)
{
	myTextureName = new char[strlen(Texture)+1];

	myID = SpriteID;
	myNext = myNewNext;
	strcpy(myTextureName, Texture);

	BITMAPINFOHEADER bih;
	ifstream File(Texture, ios::binary);
	File.seekg(sizeof(BITMAPFILEHEADER));
	File.read((char*)&bih, sizeof(BITMAPINFOHEADER));
	File.close();
	int maxPixelsX = bih.biWidth-1;
	int maxPixelsY = bih.biHeight-1;
	
	Jester->pd3dDevice->CreateVertexBuffer(4*sizeof(CFVFVertex), 0,
                           D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1, D3DPOOL_MANAGED, &myVB);

	myVB->Lock(0, 4*sizeof(CFVFVertex), (BYTE**)&myVertices, 0);

	myVertices[0].x = 0.0f;
	myVertices[0].y = 0.0f;
	myVertices[0].color = 0xffffffff;
	myVertices[0].z = 1.0;
	myVertices[0].u = (float) ((float)x1/(float)maxPixelsX);
	myVertices[0].v = (float) ((float)y2/(float)maxPixelsY);

	myVertices[1].x = 0.0f;
	myVertices[1].y = (float)y2-(float)y1;
	myVertices[1].color = 0xffffffff;
	myVertices[1].z = 1.0;
	myVertices[1].u = (float) ((float)x1/(float)maxPixelsX);
	myVertices[1].v = (float) ((float)y1/(float)maxPixelsY);

	myVertices[2].x = (float)x2-(float)x1;
	myVertices[2].y = 0.0f;
	myVertices[2].color = 0xffffffff;
	myVertices[2].z = 1.0;
	myVertices[2].u = (float) ((float)x2/(float)maxPixelsX);
	myVertices[2].v = (float) ((float)y2/(float)maxPixelsY);

	myVertices[3].x = (float)x2-(float)x1;
	myVertices[3].y = (float)y2-(float)y1;
	myVertices[3].color = 0xffffffff;
	myVertices[3].z = 1.0;
	myVertices[3].u = (float) ((float)x2/(float)maxPixelsX);
	myVertices[3].v = (float) ((float)y1/(float)maxPixelsY);

	myVB->Unlock();
}

IDirect3DVertexBuffer8* CSpriteNode::GetVertBuff(int ID)
{
	if(myID == ID) return myVB;
	else return myNext->GetVertBuff(ID);
}

char* CSpriteNode::GetTextureString(int ID)
{
	if(myID == ID) return myTextureName;
	else return myNext->GetTextureString(ID);
}

// CSpriteTail implimentation
char* CSpriteTail::GetTextureString(int ID)
{
	return 0;
}


